"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var loader_utils_1 = __importDefault(require("loader-utils"));
var schema_utils_1 = __importDefault(require("schema-utils"));
var front_matter_1 = __importDefault(require("front-matter"));
var markdown_1 = require("./markdown");
var util_1 = require("./util");
var schema = {
    type: "object",
    properties: {
        publicPath: {
            type: "string"
        },
        outputPath: {
            type: "string"
        }
    }
};
function default_1(content, map, meta) {
    var e_1, _a;
    var _b;
    // Loader options
    var options = loader_utils_1.default.getOptions(this) || {};
    schema_utils_1.default(schema, options, "Smart Markdown Loader");
    var publicPath = options.publicPath || "";
    var outputPath = options.outputPath || "";
    var data = front_matter_1.default(content);
    // Process images
    var mdImgPaths = markdown_1.getImageUrls(data.body);
    var imagePathMap = new Map(); // (mdImgPath, publicImgPath)
    try {
        for (var mdImgPaths_1 = __values(mdImgPaths), mdImgPaths_1_1 = mdImgPaths_1.next(); !mdImgPaths_1_1.done; mdImgPaths_1_1 = mdImgPaths_1.next()) {
            var mdImgPath = mdImgPaths_1_1.value;
            var imgResourcePath = path.resolve(this.context, mdImgPath);
            var imgFilename = util_1.hashFilename(imgResourcePath);
            this.addDependency(imgResourcePath);
            var outputImgPath = path.join(outputPath, imgFilename);
            var publicImgPath = path.join(publicPath, outputImgPath);
            var imgContent = this.fs.readFileSync(imgResourcePath);
            // Output images
            imagePathMap.set(mdImgPath, publicImgPath);
            this.emitFile(outputImgPath, imgContent, {});
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (mdImgPaths_1_1 && !mdImgPaths_1_1.done && (_a = mdImgPaths_1.return)) _a.call(mdImgPaths_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // Replace markdown image paths with public paths
    var replacedMd = util_1.replaceAll(data.body, imagePathMap);
    // Output markdown file
    var mdFilename = util_1.hashFilename(this.resourcePath);
    var mdFilepath = path.join(outputPath, mdFilename);
    this.emitFile(mdFilepath, replacedMd, map);
    var result = {
        meta: (_b = data.attributes, (_b !== null && _b !== void 0 ? _b : {})),
        url: path.join(publicPath, mdFilepath)
    };
    return "export default " + JSON.stringify(result);
}
exports.default = default_1;
