"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var crypto = __importStar(require("crypto"));
var _ = __importStar(require("lodash"));
function regexExecAll(re, str) {
    if (!re.global) {
        throw new Error("Regular expression must be global to match all");
    }
    var matches = [];
    var currMatch = null;
    while ((currMatch = re.exec(str)) != null) {
        matches.push(currMatch);
    }
    return matches;
}
exports.regexExecAll = regexExecAll;
function hashFilename(filename) {
    var ext = path.extname(filename);
    var hasher = crypto.createHash("sha1");
    hasher.update(filename);
    var basename = hasher.digest("hex");
    if (ext === "") {
        return basename;
    }
    else {
        return "" + basename + ext;
    }
}
exports.hashFilename = hashFilename;
function replaceAll(data, replacer) {
    var replacerKeys = Array.from(replacer.keys());
    var re = new RegExp(replacerKeys.map(function (v) { return _.escapeRegExp(v); }).join("|"), "m");
    return data.replace(re, function (substr) { return replacer.get(substr) || substr; });
}
exports.replaceAll = replaceAll;
