"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var webpack_1 = __importDefault(require("webpack"));
var memory_fs_1 = __importDefault(require("memory-fs"));
exports.outputFs = new memory_fs_1.default();
exports.default = (function (fixture, options) {
    if (options === void 0) { options = {}; }
    var compiler = webpack_1.default({
        context: __dirname,
        entry: "./" + fixture,
        output: {
            path: path_1.default.resolve(__dirname),
            filename: "bundle.js"
        },
        module: {
            rules: [
                {
                    test: /\.md$/,
                    use: {
                        loader: path_1.default.resolve(__dirname, "../../../dist/lib/loader.js"),
                        options: options
                    }
                }
            ]
        }
    });
    compiler.outputFileSystem = exports.outputFs;
    return new Promise(function (resolve, reject) {
        compiler.run(function (err, stats) {
            if (err)
                return reject(err);
            if (stats.hasErrors())
                return reject(new Error(stats.toJson().errors.join(", ")));
            resolve(stats);
        });
    });
});
